/*
 * wrappointer: A simple tool which wraps the mouse pointer to another X screen.
 *
 * Copyright (C) 2007 Christian Birchinger <cbirchinger@netswarm.net>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>

int main (int argc, char *argv[] ) {
     Display *display;

     int screen = -1;
     int curscreen = 0;

     if (argv[1])
         screen = atoi(argv[1]);

     display = XOpenDisplay(NULL);
     if (!display)
     {
         fprintf(stderr, "Cannot open display.\n");
         return 1;
     }

     curscreen = XDefaultScreen(display);
     
     if (screen == -1) {
         if ( (curscreen + 1) == ScreenCount(display) )
             screen = 0;
         else
             screen = curscreen + 1;
     }
     
     XWarpPointer(display, None, RootWindow(display, screen), 0, 0, 0, 0, 300, 300);
     XSetInputFocus(display, PointerRoot, RevertToNone, CurrentTime);

     XFlush(display);
     
     return 0;
}
